"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractMariaDBConnection = void 0;
const AbstractMySqlMariaDBConnection_1 = require("./AbstractMySqlMariaDBConnection");
class AbstractMariaDBConnection extends AbstractMySqlMariaDBConnection_1.AbstractMySqlMariaDBConnection {
    constructor(queryRunner, sqlBuilder) {
        super(queryRunner, sqlBuilder);
        this.uuidStrategy = 'uuid';
        /**
         * MariaBD 10.5 added support to the returning clause when insert or delete.
         * If you set this flag to true, the insert returning last inserted id will
         * generate the returning clause instead of use the last inserted id provided
         * by the connector after the execution of the query.
         */
        this.alwaysUseReturningClauseWhenInsert = false;
        queryRunner.useDatabase('mariaDB');
    }
}
exports.AbstractMariaDBConnection = AbstractMariaDBConnection;
