"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractMySqlConnection = void 0;
const AbstractMySqlMariaDBConnection_1 = require("./AbstractMySqlMariaDBConnection");
class AbstractMySqlConnection extends AbstractMySqlMariaDBConnection_1.AbstractMySqlMariaDBConnection {
    constructor(queryRunner, sqlBuilder) {
        super(queryRunner, sqlBuilder);
        this.uuidStrategy = 'binary';
        /**
         * The compatibility mode try to maximize the compatibility with older versions of MySQL (MySQL 5)
         *
         * The syntax avoided are:
         * - With clause, instead the query is directly included in the from
         *
         * Note: Recursive queries are not supported
         */
        this.compatibilityMode = false;
        queryRunner.useDatabase('mySql');
    }
}
exports.AbstractMySqlConnection = AbstractMySqlConnection;
