import type { OracleSqlBuilder } from "../sqlBuilders/OracleSqlBuilder";
import type { QueryRunner } from "../queryRunners/QueryRunner";
import type { Oracle, TypeSafeDB, TypeUnsafeDB } from "../databases";
import { AbstractAdvancedConnection } from "./AbstractAdvancedConnection";
export declare abstract class AbstractOracleConnection<DB extends Oracle & (TypeUnsafeDB | TypeSafeDB)> extends AbstractAdvancedConnection<DB> {
    protected uuidStrategy: 'string' | 'custom-functions';
    constructor(queryRunner: QueryRunner, sqlBuilder: OracleSqlBuilder);
    protected transformValueToDB(value: unknown, type: string): unknown;
}
