"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SequenceQueryBuilder = void 0;
const ValueSourceImpl_1 = require("../internal/ValueSourceImpl");
class SequenceQueryBuilder {
    constructor(sequenceName, columnType, columnTypeName, typeAdapter) {
        this.__sequenceName = sequenceName;
        this.__columnType = columnType;
        this.__columnTypeName = columnTypeName;
        this.__typeAdapter = typeAdapter;
    }
    nextValue() {
        return new ValueSourceImpl_1.SequenceValueSource('_nextSequenceValue', this.__sequenceName, this.__columnType, this.__columnTypeName, 'required', this.__typeAdapter);
    }
    currentValue() {
        return new ValueSourceImpl_1.SequenceValueSource('_currentSequenceValue', this.__sequenceName, this.__columnType, this.__columnTypeName, 'required', this.__typeAdapter);
    }
}
exports.SequenceQueryBuilder = SequenceQueryBuilder;
