import type { QueryRunner } from "./QueryRunner";
import { LoggingQueryRunner } from "./LoggingQueryRunner";
export type TimeGranularity = 'ms' | 'us' | 'ns';
export interface ConsoleLogQueryRunnerOpts {
    timeGranularity?: TimeGranularity;
    logTimestamps?: boolean;
    logDurations?: boolean;
    logResults?: boolean;
    paramsAsObject?: boolean;
    includeLogPhase?: boolean;
}
export declare class ConsoleLogQueryRunner<T extends QueryRunner> extends LoggingQueryRunner<T> {
    constructor(queryRunner: T, opts?: ConsoleLogQueryRunnerOpts);
}
