"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MssqlPoolPromiseQueryRunner = void 0;
const PromiseBasedPoolQueryRunner_1 = require("./PromiseBasedPoolQueryRunner");
const MssqlPoolQueryRunner_1 = require("./MssqlPoolQueryRunner");
class MssqlPoolPromiseQueryRunner extends PromiseBasedPoolQueryRunner_1.PromiseBasedPoolQueryRunner {
    constructor(promisePool) {
        super();
        this.promisePool = promisePool;
        this.database = 'sqlServer';
    }
    useDatabase(database) {
        if (database !== 'sqlServer') {
            throw new Error('Unsupported database: ' + database + '. MssqlPoolPromiseQueryRunner only supports sqlServer databases');
        }
    }
    getNativeRunner() {
        return this.promisePool;
    }
    getCurrentNativeTransaction() {
        return super.getCurrentNativeTransaction();
    }
    addParam(params, value) {
        const index = params.length;
        params.push(value);
        return '@' + index;
    }
    createQueryRunner() {
        return this.promisePool.then(pool => new MssqlPoolQueryRunner_1.MssqlPoolQueryRunner(pool));
    }
    releaseQueryRunner(_queryRunner) {
        // Do nothing
    }
}
exports.MssqlPoolPromiseQueryRunner = MssqlPoolPromiseQueryRunner;
