import type { DatabaseType } from "./QueryRunner";
import type { ConnectionPool, ISqlTypeFactory, Transaction, Request } from 'mssql';
import { PromiseBasedQueryRunner } from "./PromiseBasedQueryRunner";
export declare class MssqlPoolQueryRunner extends PromiseBasedQueryRunner {
    readonly database: DatabaseType;
    readonly pool: ConnectionPool;
    transaction?: Transaction;
    constructor(pool: ConnectionPool);
    useDatabase(database: DatabaseType): void;
    getNativeRunner(): ConnectionPool;
    getCurrentNativeTransaction(): Transaction | undefined;
    execute<RESULT>(fn: (connection: unknown, transaction?: unknown) => Promise<RESULT>): Promise<RESULT>;
    protected executeQueryReturning(query: string, params: any[]): Promise<any[]>;
    protected executeMutation(query: string, params: any[]): Promise<number>;
    executeBeginTransaction(): Promise<void>;
    executeCommit(): Promise<void>;
    executeRollback(): Promise<void>;
    isTransactionActive(): boolean;
    addParam(params: any[], value: any): string;
    protected request(): Request;
    protected predefinedTypes: {
        [type: string]: ISqlTypeFactory | undefined;
    };
    protected getType(params: any[], index: number): ISqlTypeFactory;
    protected inferType(value: any): ISqlTypeFactory;
}
