import type { DatabaseType, QueryRunner } from "./QueryRunner";
import type { Pool } from "mysql2";
import { PromiseBasedPoolQueryRunner } from "./PromiseBasedPoolQueryRunner";
export declare class MySql2PoolQueryRunner extends PromiseBasedPoolQueryRunner {
    readonly database: DatabaseType;
    readonly pool: Pool;
    constructor(pool: Pool, database?: 'mariaDB' | 'mySql');
    useDatabase(database: DatabaseType): void;
    getNativeRunner(): unknown;
    addParam(params: any[], value: any): string;
    protected createQueryRunner(): Promise<QueryRunner>;
    protected releaseQueryRunner(queryRunner: QueryRunner): void;
}
