import type { DatabaseType, QueryRunner } from "./QueryRunner";
import type { Pool } from 'oracledb';
import { PromiseBasedPoolQueryRunner } from "./PromiseBasedPoolQueryRunner";
export declare class OracleDBPoolPromiseQueryRunner extends PromiseBasedPoolQueryRunner {
    readonly database: DatabaseType;
    readonly promisePool: Promise<Pool>;
    constructor(promisePool: Promise<Pool>);
    useDatabase(database: DatabaseType): void;
    getNativeRunner(): Promise<Pool>;
    addParam(params: any[], value: any): string;
    addOutParam(params: any[], name: string): string;
    protected createQueryRunner(): Promise<QueryRunner>;
    protected releaseQueryRunner(queryRunner: QueryRunner): void;
}
