import type { DatabaseType, QueryRunner } from "./QueryRunner";
import type { Pool } from 'oracledb';
import { PromiseBasedPoolQueryRunner } from "./PromiseBasedPoolQueryRunner";
export declare class OracleDBPoolQueryRunner extends PromiseBasedPoolQueryRunner {
    readonly database: DatabaseType;
    readonly pool: Pool;
    constructor(pool: Pool);
    useDatabase(database: DatabaseType): void;
    getNativeRunner(): Pool;
    addParam(params: any[], value: any): string;
    addOutParam(params: any[], name: string): string;
    protected createQueryRunner(): Promise<QueryRunner>;
    protected releaseQueryRunner(queryRunner: QueryRunner): void;
}
