import type { DatabaseType } from "./QueryRunner";
import type { Connection } from 'oracledb';
import { PromiseBasedQueryRunner } from "./PromiseBasedQueryRunner";
export declare class OracleDBQueryRunner extends PromiseBasedQueryRunner {
    readonly database: DatabaseType;
    readonly connection: Connection;
    private transactionLevel;
    constructor(connection: Connection);
    useDatabase(database: DatabaseType): void;
    getNativeRunner(): Connection;
    getCurrentNativeTransaction(): undefined;
    execute<RESULT>(fn: (connection: unknown, transaction?: unknown) => Promise<RESULT>): Promise<RESULT>;
    protected executeQueryReturning(query: string, params: any[]): Promise<any[]>;
    protected executeMutation(query: string, params: any[]): Promise<number>;
    protected executeMutationReturning(query: string, params?: any[]): Promise<any[]>;
    executeBeginTransaction(): Promise<void>;
    executeCommit(): Promise<void>;
    executeRollback(): Promise<void>;
    isTransactionActive(): boolean;
    addParam(params: any[], value: any): string;
    addOutParam(params: any[], name: string): string;
}
