import type { UnwrapPromiseTuple } from "../utils/PromiseProvider";
import { AbstractQueryRunner } from "./AbstractQueryRunner";
export declare abstract class PromiseBasedAbstractQueryRunner extends AbstractQueryRunner {
    createResolvedPromise<RESULT>(result: RESULT): Promise<RESULT>;
    protected createAllPromise<P extends Promise<any>[]>(promises: [...P]): Promise<UnwrapPromiseTuple<P>>;
    executeCombined<R1, R2>(fn1: () => Promise<R1>, fn2: () => Promise<R2>): Promise<[R1, R2]>;
}
