"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PromiseBasedAbstractQueryRunner = void 0;
const AbstractQueryRunner_1 = require("./AbstractQueryRunner");
class PromiseBasedAbstractQueryRunner extends AbstractQueryRunner_1.AbstractQueryRunner {
    createResolvedPromise(result) {
        return Promise.resolve(result);
    }
    createAllPromise(promises) {
        return Promise.all(promises);
    }
    executeCombined(fn1, fn2) {
        return fn1().then((r1) => {
            return fn2().then((r2) => {
                return [r1, r2];
            });
        });
    }
}
exports.PromiseBasedAbstractQueryRunner = PromiseBasedAbstractQueryRunner;
